Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.google.common.collect
Class HashMultiset<E>

    java.lang.Object
      java.util.AbstractCollection<E>
          com.google.common.collect.HashMultiset<E>

All Implemented Interfaces:
  Multiset<E>, Serializable, Iterable<E>, Collection<E>

    @GwtCompatible(serializable=true,
                   emulated=true)
    public final class HashMultiset<E>

extends AbstractCollection<E>

Multiset implementation backed by a `HashMap`.

Since:
  2.0 (imported from Google Collections Library)
Author:
  Kevin Bourrillion, Jared Levy
See Also:
  Serialized Form

Nested Class Summary

Nested classes/interfaces inherited from interface com.google.common.collect.Multiset
`Multiset.Entry<E>`

Method Summary
`boolean` | `add(E element)` Adds a single occurrence of the specified element to this multiset.
`int` | `add(E element, int occurrences)` Adds a number of occurrences of an element to this multiset.
`boolean` | `addAll(Collection<? extends E> elementsToAdd)`
`void` | `clear()`
`boolean` | `contains(Object element)` Determines whether this multiset contains the specified element.
`int` | `count(Object element)` Returns the number of occurrences of an element in this multiset (the count of the element).
`static
`<E> HashMultiset<E>`
` | `create()` Creates a new, empty `HashMultiset` using the default initial capacity.
`static
`<E> HashMultiset<E>`
` | `create(int distinctElements)` Creates a new, empty `HashMultiset` with the specified expected number of distinct elements.
`static
`<E> HashMultiset<E>`
` | `create(Iterable<? extends E> elements)` Creates a new `HashMultiset` containing the specified elements.
`Set<E>` | `elementSet()` Returns the set of distinct elements contained in this multiset.
`Set<Multiset.Entry<E>>` | `entrySet()` Returns a view of the contents of this multiset, grouped into `Multiset.Entry` instances, each providing an element of the multiset and the count of that element.
`boolean` | `equals(Object object)` Compares the specified object with this multiset for equality.
`int` | `hashCode()` Returns the hash code for this multiset.
`boolean` | `isEmpty()`
`Iterator<E>` | `iterator()`
`boolean` | `remove(Object element)` Removes a single occurrence of the specified element from this multiset, if present.
`int` | `remove(Object element, int occurrences)` Removes a number of occurrences of the specified element from this multiset.
`boolean` | `removeAll(Collection<?> elementsToRemove)`
`boolean` | `retainAll(Collection<?> elementsToRetain)`
`int` | `setCount(E element, int count)` Adds or removes the necessary occurrences of an element such that the element attains the desired count.
`boolean` | `setCount(E element, int oldCount, int newCount)` Conditionally sets the count of an element to a new value, as described in `Multiset.setCount(Object, int)`, provided that the element has the expected current count.
`int` | `size()`
`String` | `toString()`

Methods inherited from class java.util.AbstractCollection
`containsAll, toArray, toArray`

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

Methods inherited from interface com.google.common.collect.Multiset
`containsAll`

Methods inherited from interface java.util.Collection
`toArray, toArray`

Method Detail

### create

    public static <E> HashMultiset<E> create()

  Creates a new, empty `HashMultiset` using the default initial capacity.

### create

    public static <E> HashMultiset<E> create(int distinctElements)

  Creates a new, empty `HashMultiset` with the specified expected number of distinct elements.

  Parameters:
    `distinctElements` - the expected number of distinct elements
  Throws:
    `IllegalArgumentException` - if `distinctElements` is negative

### create

    public static <E> HashMultiset<E> create(Iterable<? extends E> elements)

  Creates a new `HashMultiset` containing the specified elements.

  This implementation is highly efficient when `elements` is itself a `Multiset`.

  Parameters:
    `elements` - the elements that the multiset should contain

### entrySet

    public Set<Multiset.Entry<E>> entrySet()

  Returns a view of the contents of this multiset, grouped into `Multiset.Entry` instances, each providing an element of the multiset and the count of that element. This set contains exactly one entry for each distinct element in the multiset (thus it always has the same size as the `Multiset.elementSet()`). The order of the elements in the element set is unspecified.

  The entry set is backed by the same data as the multiset, so any change to either is immediately reflected in the other. However, multiset changes may or may not be reflected in any `Entry` instances already retrieved from the entry set (this is implementation-dependent). Furthermore, implementations are not required to support modifications to the entry set at all, and the `Entry` instances themselves don't even have methods for modification. See the specific implementation class for more details on how its entry set handles modifications.

  Invoking `Multiset.Entry.getCount()` on an entry in the returned set always returns the current count of that element in the multiset, as opposed to the count at the time the entry was retrieved.

  Specified by:
    `entrySet` in interface `Multiset<E>`
  Returns:
    a set of entries representing the data of this multiset

### clear

    public void clear()

  Specified by:
    `clear` in interface `Collection<E>`

### size

    public int size()

  Specified by:
    `size` in interface `Collection<E>`

### iterator

    public Iterator<E> iterator()

  Description copied from interface: `Multiset`

  Elements that occur multiple times in the multiset will appear multiple times in this iterator, though not necessarily sequentially.

  Specified by:
    `iterator` in interface `Multiset<E>`
  Specified by:
    `iterator` in interface `Iterable<E>`
  Specified by:
    `iterator` in interface `Collection<E>`

### count

    public int count(@Nullable
                     Object element)

  Description copied from interface: `Multiset`
  Returns the number of occurrences of an element in this multiset (the count of the element). Note that for an `Object.equals(java.lang.Object)`-based multiset, this gives the same result as `Collections.frequency(java.util.Collection, java.lang.Object)` (which would presumably perform more poorly).

  Note: the utility method `Iterables.frequency(java.lang.Iterable, java.lang.Object)` generalizes this operation; it correctly delegates to this method when dealing with a multiset, but it can also accept any other iterable type.

  Specified by:
    `count` in interface `Multiset<E>`
  Parameters:
    `element` - the element to count occurrences of
  Returns:
    the number of occurrences of the element in this multiset; possibly zero but never negative

### add

    public int add(@Nullable
                   E element,
                   int occurrences)

  Adds a number of occurrences of an element to this multiset. Note that if `occurrences == 1`, this method has the identical effect to `Multiset.add(Object)`. This method is functionally equivalent (except in the case of overflow) to the call `addAll(Collections.nCopies(element, occurrences))`, which would presumably perform much more poorly.

  Specified by:
    `add` in interface `Multiset<E>`
  Parameters:
    `element` - the element to add occurrences of; may be null only if explicitly allowed by the implementation
    `occurrences` - the number of occurrences of the element to add. May be zero, in which case no change will be made.
  Returns:
    the count of the element before the operation; possibly zero
  Throws:
    `IllegalArgumentException` - if the call would result in more than `Integer.MAX_VALUE` occurrences of `element` in this multiset.

### remove

    public int remove(@Nullable
                      Object element,
                      int occurrences)

  Description copied from interface: `Multiset`
  Removes a number of occurrences of the specified element from this multiset. If the multiset contains fewer than this number of occurrences to begin with, all occurrences will be removed. Note that if `occurrences == 1`, this is functionally equivalent to the call `remove(element)`.

  Specified by:
    `remove` in interface `Multiset<E>`
  Parameters:
    `element` - the element to conditionally remove occurrences of
    `occurrences` - the number of occurrences of the element to remove. May be zero, in which case no change will be made.
  Returns:
    the count of the element before the operation; possibly zero

### setCount

    public int setCount(E element,
                        int count)

  Description copied from interface: `Multiset`
  Adds or removes the necessary occurrences of an element such that the element attains the desired count.

  Specified by:
    `setCount` in interface `Multiset<E>`
  Parameters:
    `element` - the element to add or remove occurrences of; may be null only if explicitly allowed by the implementation
    `count` - the desired count of the element in this multiset
  Returns:
    the count of the element before the operation; possibly zero

### isEmpty

    public boolean isEmpty()

  Specified by:
    `isEmpty` in interface `Collection<E>`
  Overrides:
    `isEmpty` in class `AbstractCollection<E>`

### contains

    public boolean contains(@Nullable
                            Object element)

  Description copied from interface: `Multiset`
  Determines whether this multiset contains the specified element.

  This method refines `Collection.contains(java.lang.Object)` to further specify that it may not throw an exception in response to `element` being null or of the wrong type.

  Specified by:
    `contains` in interface `Multiset<E>`
  Specified by:
    `contains` in interface `Collection<E>`
  Overrides:
    `contains` in class `AbstractCollection<E>`
  Parameters:
    `element` - the element to check for
  Returns:
    `true` if this multiset contains at least one occurrence of the element

### add

    public boolean add(@Nullable
                       E element)

  Description copied from interface: `Multiset`
  Adds a single occurrence of the specified element to this multiset.

  This method refines `Collection.add(E)`, which only ensures the presence of the element, to further specify that a successful call must always increment the count of the element, and the overall size of the collection, by one.

  Specified by:
    `add` in interface `Multiset<E>`
  Specified by:
    `add` in interface `Collection<E>`
  Overrides:
    `add` in class `AbstractCollection<E>`
  Parameters:
    `element` - the element to add one occurrence of; may be null only if explicitly allowed by the implementation
  Returns:
    `true` always, since this call is required to modify the multiset, unlike other `Collection` types

### remove

    public boolean remove(Object element)

  Description copied from interface: `Multiset`
  Removes a single occurrence of the specified element from this multiset, if present.

  This method refines `Collection.remove(java.lang.Object)` to further specify that it may not throw an exception in response to `element` being null or of the wrong type.

  Specified by:
    `remove` in interface `Multiset<E>`
  Specified by:
    `remove` in interface `Collection<E>`
  Overrides:
    `remove` in class `AbstractCollection<E>`
  Parameters:
    `element` - the element to remove one occurrence of
  Returns:
    `true` if an occurrence was found and removed

### setCount

    public boolean setCount(E element,
                            int oldCount,
                            int newCount)

  Description copied from interface: `Multiset`
  Conditionally sets the count of an element to a new value, as described in `Multiset.setCount(Object, int)`, provided that the element has the expected current count. If the current count is not `oldCount`, no change is made.

  Specified by:
    `setCount` in interface `Multiset<E>`
  Parameters:
    `element` - the element to conditionally set the count of; may be null only if explicitly allowed by the implementation
    `oldCount` - the expected present count of the element in this multiset
    `newCount` - the desired count of the element in this multiset
  Returns:
    `true` if the condition for modification was met. This implies that the multiset was indeed modified, unless `oldCount == newCount`.

### addAll

    public boolean addAll(Collection<? extends E> elementsToAdd)

  This implementation is highly efficient when `elementsToAdd` is itself a `Multiset`.

  Specified by:
    `addAll` in interface `Collection<E>`
  Overrides:
    `addAll` in class `AbstractCollection<E>`

### removeAll

    public boolean removeAll(Collection<?> elementsToRemove)

  Description copied from interface: `Multiset`

  Note: This method ignores how often any element might appear in `c`, and only cares whether or not an element appears at all. If you wish to remove one occurrence in this multiset for every occurrence in `c`, see `Multisets.removeOccurrences(Multiset, Multiset)`.

  This method refines `Collection.removeAll(java.util.Collection)` to further specify that it may not throw an exception in response to any of `elements` being null or of the wrong type.

  Specified by:
    `removeAll` in interface `Multiset<E>`
  Specified by:
    `removeAll` in interface `Collection<E>`
  Overrides:
    `removeAll` in class `AbstractCollection<E>`

### retainAll

    public boolean retainAll(Collection<?> elementsToRetain)

  Description copied from interface: `Multiset`

  Note: This method ignores how often any element might appear in `c`, and only cares whether or not an element appears at all. If you wish to remove one occurrence in this multiset for every occurrence in `c`, see `Multisets.retainOccurrences(Multiset, Multiset)`.

  This method refines `Collection.retainAll(java.util.Collection)` to further specify that it may not throw an exception in response to any of `elements` being null or of the wrong type.

  Specified by:
    `retainAll` in interface `Multiset<E>`
  Specified by:
    `retainAll` in interface `Collection<E>`
  Overrides:
    `retainAll` in class `AbstractCollection<E>`
  See Also:
    `Multisets.retainOccurrences(Multiset, Multiset)`

### elementSet

    public Set<E> elementSet()

  Description copied from interface: `Multiset`
  Returns the set of distinct elements contained in this multiset. The element set is backed by the same data as the multiset, so any change to either is immediately reflected in the other. The order of the elements in the element set is unspecified.

  If the element set supports any removal operations, these necessarily cause all occurrences of the removed element(s) to be removed from the multiset. Implementations are not expected to support the add operations, although this is possible.

  A common use for the element set is to find the number of distinct elements in the multiset: `elementSet().size()`.

  Specified by:
    `elementSet` in interface `Multiset<E>`
  Returns:
    a view of the set of distinct elements in this multiset

### equals

    public boolean equals(@Nullable
                          Object object)

  Compares the specified object with this multiset for equality. Returns `true` if the given object is also a multiset and contains equal elements with equal counts, regardless of order.

  This implementation returns `true` if `object` is a multiset of the same size and if, for each element, the two multisets have the same count.

  Specified by:
    `equals` in interface `Multiset<E>`
  Specified by:
    `equals` in interface `Collection<E>`
  Overrides:
    `equals` in class `Object`

### hashCode

    public int hashCode()

  Returns the hash code for this multiset. This is defined as the sum of

         ((element == null) ? 0 : element.hashCode()) ^ count(element)

  over all distinct elements in the multiset. It follows that a multiset and its entry set always have the same hash code.

  This implementation returns the hash code of `Multiset.entrySet()`.

  Specified by:
    `hashCode` in interface `Multiset<E>`
  Specified by:
    `hashCode` in interface `Collection<E>`
  Overrides:
    `hashCode` in class `Object`

### toString

    public String toString()

  It is recommended, though not mandatory, that this method return the result of invoking `Multiset.toString()` on the `Multiset.entrySet()`, yielding a result such as `[a x 3, c, d x 2, e]`.

  This implementation returns the result of invoking `toString` on `Multiset.entrySet()`.

  Specified by:
    `toString` in interface `Multiset<E>`
  Overrides:
    `toString` in class `AbstractCollection<E>`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2010-2011. All Rights Reserved.